/*
 * Created on 17-dic-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.herac.tuxguitar.gui.actions.file;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.TypedEvent;
import org.eclipse.swt.widgets.Shell;
import org.herac.tuxguitar.gui.TuxGuitar;
import org.herac.tuxguitar.gui.actions.Action;
import org.herac.tuxguitar.gui.editors.TablatureEditor;
import org.herac.tuxguitar.gui.helper.SyncThread;
import org.herac.tuxguitar.gui.util.FileChooser;
import org.herac.tuxguitar.gui.util.MessageDialog;

/**
 * @author julian
 * 
 * TODO To change the template for this generated type comment go to Window - Preferences - Java - Code Style - Code Templates
 */
public class OpenFileAction extends Action {
    public static final String NAME = "action.file.open";
    
    private String fileName;
    
    public OpenFileAction(TablatureEditor tablatureEditor) {
        super(NAME,true, tablatureEditor);
    }

    public boolean doAction(final TypedEvent event) {    	
    	TuxGuitar.instance().getPlayer().reset();    	
    	
    	Shell parent = getEditor().getTablature().getShell();    	
    	if(event.widget.getData() instanceof String){
    		fileName = (String)event.widget.getData();
    	}else{
    		fileName = FileChooser.instance().open(parent,FileChooser.OPEN_FORMAT);
    	}
        if (fileName != null) {
            getEditor().getTablature().changeCursor(SWT.CURSOR_WAIT);
            new SyncThread(new Runnable() {
            	public void run() {
            		if(!TuxGuitar.isDisposed()){
            			try {
            				getEditor().getSongManager().open(fileName);
                            		
                            TuxGuitar.instance().getFileHistory().setFile(fileName);
                            TuxGuitar.instance().getTablatureEditor().resetDefaults();
                            TuxGuitar.instance().getMixer().update();
                            TuxGuitar.instance().getTableViewer().getTableInfo().fireUpdate();
                            TuxGuitar.instance().showTitle();
                            redraw();
                            getEditor().getTablature().changeCursor(SWT.CURSOR_ARROW);
                        }catch (Exception e) {
                        	showErrorMessage(fileName);
                			e.printStackTrace();
                			TuxGuitar.instance().getAction(NewFileAction.NAME).process(event);
                		}catch (Error e) {
                			showErrorMessage(fileName);
                			e.printStackTrace();
                		}
                    }
            	}
            }).start();
        }
        return true;
    }
    
    
    private void showErrorMessage(final String fileName){
        new SyncThread( new Runnable() {
            public void run() {
                if(!TuxGuitar.isDisposed()){
                getEditor().getTablature().changeCursor(SWT.CURSOR_ARROW);                
                String name = "Error Message";
                String message = "Cannot Open file: " + fileName;
                new MessageDialog(name,message,SWT.ICON_ERROR | SWT.OK).show(getEditor().getTablature().getShell());
                }
            }
        }).start();        
    }

}